# ASN.1 module DENM-PDU-Description
 OID: _{itu-t (0) identified-organization (4) etsi (0) itsDomain (5) wg1 (1) denmPduRelease2 (103831) version1 (1)}_

## Imports:
 * **[ITS-Container](ITS-Container.md)** *{ itu-t (0) identified-organization (4) etsi (0) itsDomain (5) wg1 (1) ts (102894) cdd (2) version3 (3)}*<br/>
  
## Data Elements:
### <a name="DENM"></a>DENM

Fields:
* header [**ItsPduHeader**](ITS-Container.md#ItsPduHeader) <br>
* denm [**DenmPayload**](#DenmPayload) <br>
   
```asn1
DENM ::= SEQUENCE {
	header ItsPduHeader,
	denm   DenmPayload
}
```

### <a name="DenmPayload"></a>DenmPayload

Fields:
* management [**ManagementContainer**](#ManagementContainer) <br>
* situation [**SituationContainer**](#SituationContainer)  OPTIONAL<br>
   
* location [**LocationContainer**](#LocationContainer)  OPTIONAL<br>
   
* alacarte [**AlacarteContainer**](#AlacarteContainer)  OPTIONAL<br>
   
```asn1
DenmPayload ::= SEQUENCE {
	management ManagementContainer,
	situation  SituationContainer OPTIONAL,
	location   LocationContainer OPTIONAL,
	alacarte   AlacarteContainer OPTIONAL
}
```

### <a name="ManagementContainer"></a>ManagementContainer

Fields:
* actionID [**ActionID**](ITS-Container.md#ActionID) <br>
* detectionTime [**TimestampIts**](ITS-Container.md#TimestampIts) <br>
   
* referenceTime [**TimestampIts**](ITS-Container.md#TimestampIts) <br>
   
* termination [**Termination**](#Termination)  OPTIONAL<br>
   
* eventPosition [**ReferencePosition**](ITS-Container.md#ReferencePosition) <br>
   
* awarenessDistance [**StandardLength3b**](ITS-Container.md#StandardLength3b)  OPTIONAL<br>
   
* awarenessTrafficDirection [**TrafficDirection**](ITS-Container.md#TrafficDirection)  OPTIONAL<br>
   
* validityDuration [**DeltaTimeSecond**](ITS-Container.md#DeltaTimeSecond)  DEFAULT defaultValidity<br>
   
* transmissionInterval [**DeltaTimeMilliSecondPos**](ITS-Container.md#DeltaTimeMilliSecondPos)  OPTIONAL<br>
    
* stationType [**StationType**](ITS-Container.md#StationType) <br>
   
```asn1
ManagementContainer ::= SEQUENCE {
	actionID                  ActionID,
	detectionTime             TimestampIts,
	referenceTime             TimestampIts,
	termination               Termination OPTIONAL,
	eventPosition             ReferencePosition,
	awarenessDistance         StandardLength3b OPTIONAL,
	awarenessTrafficDirection TrafficDirection OPTIONAL,
	validityDuration          DeltaTimeSecond DEFAULT defaultValidity, 
	transmissionInterval      DeltaTimeMilliSecondPos OPTIONAL,
	stationType               StationType,
	...
}
```

### <a name="SituationContainer"></a>SituationContainer

Fields:
* informationQuality [**InformationQuality**](ITS-Container.md#InformationQuality) <br>
* eventType [**CauseCodeV2**](ITS-Container.md#CauseCodeV2) <br>
   
* linkedCause [**CauseCodeV2**](ITS-Container.md#CauseCodeV2)  OPTIONAL<br>
   
* eventZone [**EventZone**](ITS-Container.md#EventZone)  OPTIONAL<br>
   
```asn1
SituationContainer ::= SEQUENCE {
	informationQuality InformationQuality,
	eventType          CauseCodeV2,
	linkedCause        CauseCodeV2 OPTIONAL,
	eventZone          EventZone OPTIONAL,
	...
}
```

### <a name="LocationContainer"></a>LocationContainer

Fields:
* eventSpeed [**Speed**](ITS-Container.md#Speed)  OPTIONAL<br>
* eventPositionHeading [**Wgs84Angle**](ITS-Container.md#Wgs84Angle)  OPTIONAL<br>
   
* traces [**Traces**](ITS-Container.md#Traces) <br>
   
* roadType [**RoadType**](ITS-Container.md#RoadType)  OPTIONAL<br>
   
```asn1
LocationContainer ::= SEQUENCE {
	eventSpeed           Speed OPTIONAL,
	eventPositionHeading Wgs84Angle OPTIONAL,
	traces               Traces,
	roadType             RoadType OPTIONAL,
	...
}
```

### <a name="ImpactReductionContainer"></a>ImpactReductionContainer

Fields:
* heightLonCarrLeft [**HeightLonCarr**](ITS-Container.md#HeightLonCarr) <br>
* heightLonCarrRight [**HeightLonCarr**](ITS-Container.md#HeightLonCarr) <br>
   
* posLonCarrLeft [**PosLonCarr**](ITS-Container.md#PosLonCarr) <br>
   
* posLonCarrRight [**PosLonCarr**](ITS-Container.md#PosLonCarr) <br>
   
* positionOfPillars [**PositionOfPillars**](ITS-Container.md#PositionOfPillars) <br>
   
* posCentMass [**PosCentMass**](ITS-Container.md#PosCentMass) <br>
   
* wheelBaseVehicle [**WheelBaseVehicle**](ITS-Container.md#WheelBaseVehicle) <br>
   
* turningRadius [**TurningRadius**](ITS-Container.md#TurningRadius) <br>
   
* posFrontAx [**PosFrontAx**](ITS-Container.md#PosFrontAx) <br>
   
* positionOfOccupants [**PositionOfOccupants**](ITS-Container.md#PositionOfOccupants) <br>
   
* vehicleMass [**VehicleMass**](ITS-Container.md#VehicleMass) <br>
   
* requestResponseIndication [**RequestResponseIndication**](ITS-Container.md#RequestResponseIndication) <br>
   
```asn1
ImpactReductionContainer ::= SEQUENCE {
	heightLonCarrLeft         HeightLonCarr,
	heightLonCarrRight        HeightLonCarr,
	posLonCarrLeft            PosLonCarr,
	posLonCarrRight           PosLonCarr,
	positionOfPillars         PositionOfPillars,
	posCentMass               PosCentMass,
	wheelBaseVehicle          WheelBaseVehicle,
	turningRadius             TurningRadius,
	posFrontAx                PosFrontAx,
	positionOfOccupants       PositionOfOccupants,
	vehicleMass               VehicleMass,
	requestResponseIndication RequestResponseIndication
}
```

### <a name="RoadWorksContainerExtended"></a>RoadWorksContainerExtended

Fields:
* lightBarSirenInUse [**LightBarSirenInUse**](ITS-Container.md#LightBarSirenInUse)  OPTIONAL<br>
* closedLanes [**ClosedLanes**](ITS-Container.md#ClosedLanes)  OPTIONAL<br>
   
* restriction [**RestrictedTypes**](ITS-Container.md#RestrictedTypes)  OPTIONAL<br>
   
* speedLimit [**SpeedLimit**](ITS-Container.md#SpeedLimit)  OPTIONAL<br>
   
* incidentIndication [**CauseCodeV2**](ITS-Container.md#CauseCodeV2)  OPTIONAL<br>
   
* recommendedPath [**ItineraryPath**](ITS-Container.md#ItineraryPath)  OPTIONAL<br>
   
* startingPointSpeedLimit [**DeltaReferencePosition**](ITS-Container.md#DeltaReferencePosition)  OPTIONAL<br>
   
* trafficFlowRule [**TrafficRule**](ITS-Container.md#TrafficRule)  OPTIONAL<br>
   
* referenceDenms [**ActionIdList**](ITS-Container.md#ActionIdList)  OPTIONAL<br>
   
```asn1
RoadWorksContainerExtended ::= SEQUENCE {
	lightBarSirenInUse      LightBarSirenInUse OPTIONAL,
	closedLanes             ClosedLanes OPTIONAL,
	restriction             RestrictedTypes OPTIONAL,
	speedLimit              SpeedLimit OPTIONAL,
	incidentIndication      CauseCodeV2 OPTIONAL,
	recommendedPath         ItineraryPath OPTIONAL,
	startingPointSpeedLimit DeltaReferencePosition OPTIONAL,
	trafficFlowRule         TrafficRule OPTIONAL,
	referenceDenms          ActionIdList OPTIONAL
 }
```

### <a name="StationaryVehicleContainer"></a>StationaryVehicleContainer

Fields:
* stationarySince [**StationarySince**](ITS-Container.md#StationarySince)  OPTIONAL<br>
* stationaryCause [**CauseCodeV2**](ITS-Container.md#CauseCodeV2)  OPTIONAL<br>
    
* carryingDangerousGoods [**DangerousGoodsExtended**](ITS-Container.md#DangerousGoodsExtended)  OPTIONAL<br>
   
* numberOfOccupants [**NumberOfOccupants**](ITS-Container.md#NumberOfOccupants)  OPTIONAL<br>
   
* vehicleIdentification [**VehicleIdentification**](ITS-Container.md#VehicleIdentification)  OPTIONAL<br>
   
* energyStorageType [**EnergyStorageType**](ITS-Container.md#EnergyStorageType)  OPTIONAL<br>
   
```asn1
StationaryVehicleContainer ::= SEQUENCE {
	stationarySince        StationarySince OPTIONAL, 
	stationaryCause        CauseCodeV2 OPTIONAL,
	carryingDangerousGoods DangerousGoodsExtended OPTIONAL,
	numberOfOccupants      NumberOfOccupants OPTIONAL,
	vehicleIdentification  VehicleIdentification OPTIONAL,
	energyStorageType      EnergyStorageType OPTIONAL
}
```

### <a name="AlacarteContainer"></a>AlacarteContainer

Fields:
* lanePosition [**LanePosition**](ITS-Container.md#LanePosition)  OPTIONAL<br>
* impactReduction [**ImpactReductionContainer**](#ImpactReductionContainer)  OPTIONAL<br>
   
* externalTemperature [**Temperature**](ITS-Container.md#Temperature)  OPTIONAL<br>
   
* roadWorks [**RoadWorksContainerExtended**](#RoadWorksContainerExtended)  OPTIONAL<br>
   
* positioningSolution [**PositioningSolutionType**](ITS-Container.md#PositioningSolutionType)  OPTIONAL<br>
   
* stationaryVehicle [**StationaryVehicleContainer**](#StationaryVehicleContainer)  OPTIONAL<br>
   
```asn1
AlacarteContainer ::= SEQUENCE {
	lanePosition        LanePosition OPTIONAL,
	impactReduction     ImpactReductionContainer OPTIONAL,
	externalTemperature Temperature OPTIONAL,
	roadWorks           RoadWorksContainerExtended OPTIONAL,
	positioningSolution PositioningSolutionType OPTIONAL,
	stationaryVehicle   StationaryVehicleContainer OPTIONAL,
	...
}
```

```asn1
defaultValidity INTEGER ::= 600
```


### <a name="Termination"></a>Termination
```asn1
Termination ::= ENUMERATED {isCancellation(0), isNegation (1)}
```



